//////////////////////////////////////////////////////////// 
//
//   <autogenerated>
//      WARNING: This code was generated from CDL by a tool.
//
//      Changes to this file may cause incorrect behavior
//      and will be lost if the code is regenerated.
//   </autogenerated>
//
//   Template Version:
//
//      CORE v4.0.0 for ANSI C++ v1.0.0 (14/11/2007)
//    
////////////////////////////////////////////////////////////

#include <Base/Infrastructure/Circuitry/MyProcessProcessBase.hpp>

// GLOBAL NAMESPACE {

   /// <summary>
   /// Called to start-up this CLIP process.
   /// </summary>
   /// <param name="processEvents">Process events interface</param>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::Startup( IMyProcessProcessEvents *processEvents )
   {
      Uns failed = FALSE;
      Uns i;
      Uns roleConfigured = FALSE;
      Char* activeConfigType = NULL;
      
      // Configure the process
      if ( AmRootMaster() )
      {
         // Configure as a root-master

         activeConfigType = "Root-Master";
      }
      else if ( AmSubMaster() )
      {
         // Configure as a sub-master

         activeConfigType = "Sub-Master";
      }
      else if ( AmSlave() )
      {
         // Configure as a slave
 
         activeConfigType = "Slave";
     }
      else if ( AmAutonomous() )
      {
         // Configure as autonomous
         m_diagHandler = NULL;
         m_handleDiagEvents = TRUE;

         m_thisProcName = "AutonomousProcessRole1";
         m_heapSize = MB(256);
         m_cacheSize = MB(256) / CLP_FAST_CACHE_PART;
         m_heapFlags = CLP_MEM_SHARED;
         m_heapFlags |= CLP_MEM_OFF_LINE;
         m_heapFlags |= CLP_MEM_FAST;
         if (!drv_bsp_segs_create (m_heapSize, m_cacheSize, m_heapFlags))
            return FALSE;

         // Unused parameters for autonomous mode
         m_regAddress = "";
         m_masterName = "";
         m_minNumSlaves = 0;
         m_maxNumSlaves = 0;
         m_subMasterId = 0;
         
         // Configure diagnostic logging to file
         m_isDiagEnabled = FALSE;
         m_diagFile = NULL;
        
         roleConfigured = TRUE;
 
         activeConfigType = "Autonomous";
      }
      
      // Ensure that the process is configured
      if ( !roleConfigured )
      {
         Char errStr[1024];
         sprintf( errStr, "Startup() failed for process MyProcess because the %s role was not configured.%c", activeConfigType, 0x0a );
         ClpDiag( errStr );
      }

      // Instance name
      Char *instanceName = "Default";

      // Parent domain
      Char *parentDomain = "Default";

      // Registrar address length
      Uns  regAddressLen = strlen( m_regAddress ) + 1;

      // Set up diagnostic output file
      if ( m_isDiagEnabled )
      {
         clp_open_diag_file( m_diagFile );
      }

      // Set up default worker counts
      Uns maxWorkerConcurrency[CLP_MAX_PRIO];
      Uns workerConcurrency[CLP_MAX_PRIO];
      Uns workerHeapSize[CLP_MAX_PRIO];
      Uns workerCacheSize[CLP_MAX_PRIO];
      Uns workerHeapFlags[CLP_MAX_PRIO];
      m_initNumWorkers = ClpNumProcessors();
      if ( m_initNumWorkers < 1 ) m_initNumWorkers = 1;
      m_maxNumWorkers = CLP_UNLIMITED_WORKERS;
      Uns wrkrHeapFlgs = 0;
      for ( i = 0; i < CLP_MAX_PRIO; i++ )
      {
         workerConcurrency[i] = m_initNumWorkers;
         maxWorkerConcurrency[i] = m_maxNumWorkers;
         workerHeapSize[i] = MB(1);
         workerHeapFlags[i] = wrkrHeapFlgs;
      }
      
      // Apply overridden worker settings

      // Set worker counts
      for ( i = 0; i < CLP_MAX_PRIO; i++ )
      {
         ClpSetWorkerConcurrency( i, workerConcurrency[i] );
         ClpSetMaxWorkerConcurrency( i, maxWorkerConcurrency[i] );
         ClpSetWorkerHeapSize( i, workerHeapSize[i] );
         ClpSetWorkerCacheSize( i, workerCacheSize[i] );
         ClpSetWorkerHeapFlags( i, workerHeapFlags[i] );
      }
      
      if ( processEvents != NULL )
      {
         m_processEvents = processEvents;
         failed |= ! ClpMainCct::Startup(
            instanceName,
            parentDomain,
            m_thisProcName,
            m_heapSize,
            m_cacheSize,
            m_heapFlags,
            0,
            regAddressLen,
            m_regAddress,
            m_masterName,
            m_minNumSlaves,
            m_maxNumSlaves,
            m_subMasterId,
            this );
      }
      else
      {
         failed = TRUE;
      }
      
      return ! failed;
   }
      
   /// <summary>
   /// Signals a non-CLIP thread that a diagnostic has been raised.
   /// </summary>
   void MyProcessProcessBase::AppDiagCbf( char *diagStr )
   {
      if ( m_handleDiagEvents ) ::CLIP::SignalDiag( m_diagHandler );
   }

   /// <summary>
   /// Called before this process is started.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::OnPrestart()
   {
      Uns failed = FALSE;
      
      return !failed;
   }

   /// <summary>
   /// Called when this process is created.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::OnCreate()
   {
      Uns failed = FALSE;
      
      failed |= ! mMyDefn1Cct.Create();
      
      if ( m_handleCreateEvents ) ::CLIP::SignalCctEvent( m_createHandler, !failed );
      
      return !failed;
   }

   /// <summary>
   /// Called when this process is connected.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::OnConnect()
   {
      Uns failed = FALSE;
      
      failed |= ! mMyDefn1Cct.Connect();
      
      if ( m_handleConnectEvents ) ::CLIP::SignalCctEvent( m_connectHandler, !failed );
      
      return !failed;
   }

   /// <summary>
   /// Called when this process is initialized.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::OnInitialise()
   {
      Uns failed = FALSE;

      failed |= ! mMyDefn1Cct.Initialise();
      
      if ( m_handleInitEvents ) ::CLIP::SignalCctEvent( m_initializeHandler, !failed );
      
      return !failed;
   }

   /// <summary>
   /// Called when this process is integrated.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::OnIntegrate()
   {
      Uns failed = FALSE;
      
      failed |= ! mMyDefn1Cct.Integrate( NULL );
      
      if ( m_handleIntegrateEvents ) ::CLIP::SignalCctEvent( m_integrateHandler, !failed );
      
      return !failed;
   }

   /// <summary>
   /// Called when this process is activated.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::OnActivate()
   {
      Uns failed = FALSE;
      
      failed |= ! mMyDefn1Cct.Activate();
      
      if ( m_handleActivateEvents ) ::CLIP::SignalCctEvent( m_activateHandler, !failed );
      
      return !failed;
   }

   /// <summary>
   /// Called when this process is exited.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyProcessProcessBase::OnExit()
   {
      Uns failed = FALSE;
      
      failed |= ! mMyDefn1Cct.Exit();
      
      if ( m_handleExitEvents ) ::CLIP::SignalCctEvent( m_exitHandler, !failed );

      return !failed;
   }
      
// } GLOBAL NAMESPACE
////////////////////////////////////////////////////////////

